using System;
using System.Collections.ObjectModel;
using CODE.Framework.Wpf.Mvvm;

namespace MyBusinessApplication.Models.Customer
{
public class SearchViewModel : ListViewModel
{
    public SearchViewModel() : base(false)
    {
        SearchCustomers = new ViewAction("Search", execute: (a,o) => Search());
    }

    public IViewAction SearchCustomers { get; set; }

    public void Search()
    {
        // TODO: Perform actual search here... but for now we just load the fake data
        LoadCustomers();
    }

    // Example search terms
    public string SearchTerm1 { get; set; }
    public string SearchTerm2 { get; set; }
    public string SearchTerm3 { get; set; }
    public string SearchTerm4 { get; set; }
    public string SearchTerm5 { get; set; }
}

    public class ListViewModel : ViewModel
    {
        public ListViewModel(bool loadCustomers = true)
        {
            Customers = new ObservableCollection<CustomerInformation>();
            if (loadCustomers)
                LoadCustomers();

            Actions.Add(new CloseCurrentViewAction(this, beginGroup: true));
            EditCustomer = new ViewAction("Edit", execute: (a,o) => LaunchEdit(o as CustomerInformation));
        }

        public IViewAction EditCustomer { get; set; }

        public ObservableCollection<CustomerInformation> Customers { get; set; }

        public void LoadCustomers()
        {
            // This is fake data! We should probably access a service or so...
            for (int x = 0; x < 100; x++)
                Customers.Add(new CustomerInformation
                                  {
                                      FirstName = "Markus",
                                      LastName = "Egger",
                                      Company = "EPS/CODE"
                                  });
        }

        public void LaunchEdit(CustomerInformation customer)
        {
            // Pretending to load a specific customer
            Controller.Action("Customer", "Edit", new {id = Guid.Empty});
        }
    }

    public class CustomerInformation
    {
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string Company { get; set; }
    }
}
